#include<iostream>


using namespace std;
int bk(int n, int k)
{
    int i=1;
    int p=1;
    for(i;i<=k;i++)
    {
        p=(p*(n-i+1))/i;
    }
    return p;
}



int main()
{
    int n,m;
    cin>> n>>m;
    double s[n][m];
    for(int i=0;i<n;i++)
    {   cout<<endl;
        for(int j=0;j<m;j++)cin>>s[i][j];

    }
    int k=min(n,m);
    int a=n+m-k;
    int fakt=1;
    for(int i=2;i<=k;i++)fakt*=i;
    cout<<bk(a,k)*fakt;


}